SystemOrganization addCategory: #SwazooSpike!

Object subclass: #S2JClient
	instanceVariableNames: 'revision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JClient class methodsFor: 'configuration' stamp: 'HK 1/4/2011 14:22'!
defaultRevision

	^ 0.! !

!S2JClient methodsFor: 'convenience' stamp: 'HK 1/3/2011 14:28'!
adaptRevision

	self revision: S2JDispatcher revision.! !

!S2JClient methodsFor: 'convenience' stamp: 'HK 1/4/2011 14:16'!
increaseRevision

	self revision: (self revision + 1).
	Transcript show: self revision.! !

!S2JClient methodsFor: 'initialization' stamp: 'HK 1/4/2011 14:20'!
initialize

	self revision: self class defaultRevision.! !

!S2JClient methodsFor: 'initialization' stamp: 'HK 1/5/2011 16:52'!
isAlive 

	self subclassResponsibility.! !

!S2JClient methodsFor: 'convenience' stamp: 'HK 1/4/2011 14:13'!
isBehind

	^ self revision < S2JDispatcher revision.! !

!S2JClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:17'!
isCometClient

	^ self subclassResponsibility.! !

!S2JClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:17'!
isWebSocketClient

	^ self subclassResponsibility.! !

!S2JClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 22:35'!
revision
	^ revision! !

!S2JClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 22:35'!
revision: anObject
	revision := anObject! !

S2JClient subclass: #S2JCometClient
	instanceVariableNames: 'identifier keepAliveCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JCometClient class methodsFor: 'configuration' stamp: 'HK 1/10/2011 13:59'!
defaultKeepAliveCount

	^ 100.! !

!S2JCometClient methodsFor: 'convenience' stamp: 'HK 1/5/2011 17:03'!
decrementKeepAliveCount

	self keepAliveCount: self keepAliveCount - 1.! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 14:34'!
identifier
	^ identifier! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 14:34'!
identifier: anObject
	identifier := anObject! !

!S2JCometClient methodsFor: 'convenience' stamp: 'HK 1/5/2011 17:10'!
increaseRevision

	super increaseRevision.
	self resetKeepAliveCount.! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 1/5/2011 17:06'!
initialize

	super initialize.
	self keepAliveCount: self class defaultKeepAliveCount.! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:54'!
isAlive

	^ self keepAliveCount > 0.! !

!S2JCometClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isCometClient

	^ true.! !

!S2JCometClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isWebSocketClient

	^ false.! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:51'!
keepAliveCount
	^ keepAliveCount! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:51'!
keepAliveCount: anObject
	keepAliveCount := anObject! !

!S2JCometClient methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:51'!
resetKeepAliveCount

	self keepAliveCount: self class defaultKeepAliveCount.! !

S2JClient subclass: #S2JWebSocketClient
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebSocketClient class methodsFor: 'instance creation' stamp: 'HK 12/15/2010 21:46'!
newWithSocket: aWebSocket

	^ self basicNew socket: aWebSocket; initialize.! !

!S2JWebSocketClient methodsFor: 'convenience' stamp: 'HK 1/3/2011 16:07'!
close

	self isOpen ifTrue: [ self socket close ].
	S2JDispatcher removeClient: self.! !

!S2JWebSocketClient methodsFor: 'configuration' stamp: 'HK 1/3/2011 22:33'!
defaultReceiveBlock

	^ [ :message |
		S2JDispatcher updateContentWith: message.
		S2JWebSocketHandler updateAllClientsExcept: self ].! !

!S2JWebSocketClient methodsFor: 'initialization' stamp: 'HK 1/3/2011 22:34'!
initialize

	super initialize.
	self socket receiveBlock: self defaultReceiveBlock.! !

!S2JWebSocketClient methodsFor: 'convenience' stamp: 'HK 1/5/2011 16:53'!
isAlive
	
	^ self socket isOpen and: [ self socket connection stream notNil ].! !

!S2JWebSocketClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isCometClient

	^ false.! !

!S2JWebSocketClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isWebSocketClient

	^ true.! !

!S2JWebSocketClient methodsFor: 'convenience' stamp: 'HK 1/5/2011 16:53'!
send: aMessage

	self isAlive
		ifTrue: [ self socket send: aMessage ]
		ifFalse: [ S2JDispatcher removeClient: self ].! !

!S2JWebSocketClient methodsFor: 'accessing' stamp: 'HK 12/14/2010 10:20'!
socket
	^ socket! !

!S2JWebSocketClient methodsFor: 'accessing' stamp: 'HK 12/14/2010 10:20'!
socket: anObject
	socket := anObject! !

!S2JWebSocketClient methodsFor: 'convenience' stamp: 'LT 1/5/2011 09:53:15.184'!
update

	 [ self isBehind ] whileTrue: [self increaseRevision. self send: (S2JDispatcher contentAtRevision: self revision) ]
		! !

SwazooResource subclass: #S2JResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

S2JResource subclass: #S2JApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JApp methodsFor: 'request handling' stamp: 'HK 1/4/2011 12:13'!
answerTo: aRequest

	^ HTTPResponse ok entity: self renderWebsite.! !

!S2JApp methodsFor: 'rendering' stamp: 'HK 1/3/2011 21:33'!
cssData 

	^ 'body {
		font-family: Verdana;
		margin: 0px;
		padding: 0px;
	}
	
	#container {
		width: 80%;
		margin: 0px auto;
	}
	
	textarea {
		width: 100%;
		background-color: #F9F7ED;
		border: 1px solid #4096EE;
	}
	
	table {
		width: 100%;
	}
	
	th {
		text-align: left;
		width: 40%;
	}

	tr th:nth-child(1), tr th:nth-child(2){
		width: 10%;	
	}
	
	.red {
		background-color: #D15600;
	}
	
	.yellow {
		background-color: #FFFF88;
	}
	
	.green {
		background-color: #6BBA70;
	}
	
	.blue {
		background-color: #C3D9FF;
	}
	'.! !

!S2JApp methodsFor: 'rendering' stamp: 'HK 12/17/2010 13:34'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!S2JApp methodsFor: 'javascript' stamp: 'HK 1/5/2011 16:33'!
javascriptCode

	^ self kernelPrimitives,'
	var preferWs = false;
	var data = null;
	var webSocket = null;
	var request = null;
	var identifier = null;
	
	function isWsSupported() {
		return ("WebSocket" in window);
	}
	
	function useWs() {
		return (isWsSupported() && preferWs);
	}
	
	// common functions
	
	function connect() {
		useWs() ? openSocket() : openComet();
	}
	
	function send() {
		data = document.getElementById("input").value;
		if (data !!= "") {
			useWs() ? sendSocket(data) : sendComet(data);
		}
	}
	
	function disconnect() {
		useWs() ? closeSocket() : closeComet();
	}

	// comet functions

	function createXmlRequest() {
		return new XMLHttpRequest();
	}
	
	function cometUrl() {
		if (identifier !!= null) return "/xhr?id=" + identifier;
		return "/xhr";
	}
	
	function openComet() {
		if (request == null) poll();
	}
		
	function poll() {
		request = createXmlRequest();
		request.open("GET", cometUrl(), true);
		request.onreadystatechange = pollResponseHandler;
		request.send(null);
	}
	
	function pollResponseHandler() {
		if (request.readyState == 4) {
			if (request.status == 200) {
				var content = request.responseText;
				log(request.status, content);
				poll();
			}
			else if (request.status == 202) {
				identifier = request.responseText;
				info("Registered with id " + identifier);
				poll();
			}
			else info("disconnected");
		}
	}
	
	function sendComet(data) {
		stop();
		request = createXmlRequest();
		request.open("POST", cometUrl(), true);
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.onreadystatechange = sendResponseHandler;
		request.send(encodeURIComponent(data));
	}
	
	function sendResponseHandler() {	
		if ((request.readyState == 4) && (request.status == 201)) {
			log(201, data);
			poll();
		}
	}
	
	function closeComet() {
		if (request !!= null) {
			request.abort();
			request = null;
		}
	}
	
	// WebSocket
	
	function openSocket() {
		webSocket = new WebSocket("ws://localhost:8887/ws");
		
		webSocket.onopen = function(event) {
			info("Successfully opened WebSocket.");
		}
		
		webSocket.onerror = function(event) {
			log("WebSocket failed.");
		}
		
		webSocket.onmessage = function(event) {
			log(200, event.data)
		}
		
		webSocket.onclose = function() {
			info("WebSocket received close event.");
		}
	}
	
	function sendSocket(message) {
		if (webSocket !!= null) {
			webSocket.send(message);
			log(200, message);
		}
	}

	function closeSocket() {
		if (webSocket !!= null) {
			info("WebSocket closed by client.");
			webSocket.close();
			webSocket = null;
		}
	}
	
	'.! !

!S2JApp methodsFor: 'javascript' stamp: 'HK 1/3/2011 21:51'!
javascriptCodeForUI

	^ '
	
	function log(text) {
		prependRow("green", text, null);
	}
	
	function info(text) {
		prependRow("blue", null, text, null);
	}
	
	function log(httpStatus, content) {
		if ((httpStatus == 200) || (httpStatus == 201)) {
			var evaluatedContent;
			try {
  				evaluatedContent = eval(content);
				prependRow("green", httpStatus, content, evaluatedContent);
			}
			catch(error) {
				prependRow("red", httpStatus, content, error);
			}
		}
		else if (httpStatus == 204) {
			prependRow("yellow", httpStatus, "No content", "");
		}
		else {
			prependRow("yellow", httpStatus, "Client aborted", "");
		} 
	}
		
	function prependRow(cssClass, httpStatus, logText, evalText) {
		var tbody = document.getElementsByTagName("tbody")[0];
		var firstRow = tbody.getElementsByTagName("tr")[0];
		var newRow = row(cssClass, httpStatus, logText, evalText);
		tbody.insertBefore(newRow, firstRow);
	}
	
	function row(cssClass, httpStatus, logText, evalText) {
		var row = document.createElement("tr");
		row.setAttribute("class", cssClass);
		var httpData = document.createElement("td");
		httpData.innerHTML = httpStatus;
		row.appendChild(httpData);
		var timeData = document.createElement("td");
		timeData.innerHTML = getTime();
		row.appendChild(timeData);
		var logData = document.createElement("td");
		logData.innerHTML = logText;
		row.appendChild(logData);
		var evalData = document.createElement("td");
		evalData.innerHTML = evalText;
		row.appendChild(evalData);
		return row;
	}
	
	function getTime() {
		var now = new Date();
		var hours = twoDigit(now.getHours());
		var minutes = twoDigit(now.getMinutes());
		var seconds = twoDigit(now.getSeconds());
		return hours + ":" + minutes + ":" + seconds;
	}
	
	function twoDigit(digit) {
		if (digit < 10) return "0" + digit;
		return digit;
	}
	
	function clearLog() {
		var tbody = document.getElementsByTagName("tbody")[0];
		while (tbody.childNodes.length > 0) {
			tbody.removeChild(tbody.childNodes[0]);
		}
	}
	'.! !

!S2JApp methodsFor: 'javascript' stamp: 'LT 1/5/2011 09:59:55.344'!
kernelPrimitives

	^ ' Number.prototype._plus = function(anotherNumber){ return this +  anotherNumber };
Number.prototype._minus = function(anotherNumber){ return this -  anotherNumber };
Number.prototype._at = function(anotherNumber){ return Point.x_y_(this, anotherNumber); }'! !

!S2JApp methodsFor: 'rendering' stamp: 'LT 1/5/2011 10:02:31.18'!
renderBody

	^ '<body>
	<div id="container">',
	'<canvas id="ballCanvas" width="300" height="300" style="background-color: #ffffff; border: solid 1px #000000;"></canvas>',
	self renderContent,
	'</div></body></html>'! !

!S2JApp methodsFor: 'rendering' stamp: 'HK 1/4/2011 11:09'!
renderContent

	^ '<h3>Push your code</h3>
	<p><textarea id="input"></textarea></p>
	<p><input type="button" value="Send data" onclick="send();"></p>
	<h3>Log</h3>
	<p>
	<input type="button" value="Connect" onclick="connect();">
	<input type="button" value="Disconnect" onclick="disconnect();">
	<input type="button" value="Clear log" onclick="clearLog();">
	</p>
	<table>
	<thead>
	<tr>
	<th>Status</th>
	<th>Time</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	'.! !

!S2JApp methodsFor: 'rendering' stamp: 'HK 12/17/2010 14:13'!
renderHeader

	^ self htmlDocumentType,
	'<html><head><title>',
	self class siteName,
	'</title><script type="text/javascript">',
	self javascriptCodeForUI,
	'</script><script type="text/javascript">',
	self javascriptCode,
	'</script><style type="text/css"><!!--',
	self cssData,
	'--></style></head>'.! !

!S2JApp methodsFor: 'rendering' stamp: 'HK 12/17/2010 14:09'!
renderWebsite

	^ self renderHeader, self renderBody.! !

!S2JApp methodsFor: 'rendering' stamp: 'HK 12/17/2010 13:34'!
xmlDocumentType

	^ '<?xml version="1.0"?>'.
! !

S2JResource subclass: #S2JCometHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JCometHandler class methodsFor: 'configuration' stamp: 'HK 12/15/2010 20:16'!
defaultMillisecondsToWait

	^ 100.! !

!S2JCometHandler class methodsFor: 'configuration' stamp: 'HK 12/15/2010 15:39'!
identifierRange

	^ 10e10.! !

!S2JCometHandler methodsFor: 'responding' stamp: 'HK 1/3/2011 21:37'!
answerNewContentTo: aClient

	aClient increaseRevision.
	^ self
		answerWithStatusCode: 200
		andContent: (S2JDispatcher contentAtRevision: aClient revision).! !

!S2JCometHandler methodsFor: 'responding' stamp: 'HK 1/3/2011 20:30'!
answerNewIdentifier: anIdentifier

	^ self
		answerWithStatusCode: 202
		andContent: anIdentifier.! !

!S2JCometHandler methodsFor: 'responding' stamp: 'HK 12/17/2010 13:57'!
answerNoContent

	^ self answerWithStatusCode: 204.! !

!S2JCometHandler methodsFor: 'request handling' stamp: 'HK 1/10/2011 13:19'!
answerTo: aRequest

	aRequest isGet ifTrue: [ ^ self handleGetRequest: aRequest ].
	aRequest isPost ifTrue: [ ^ self handlePostRequest: aRequest ].! !

!S2JCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 13:29'!
extractIdentifierFrom: aRequest

	(self includesIdentifier: aRequest) ifFalse: [ ^ nil ].
	^ (aRequest requestLine requestURI asString subStrings: '?id=') at: 2.! !

!S2JCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 14:23'!
findClientById: anIdentifier

	^ S2JDispatcher clients
		detect: [ :uniqueClient |
			uniqueClient isCometClient and:
				[ uniqueClient identifier = anIdentifier ]]
		ifNone: [ nil ].! !

!S2JCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 12:14'!
generateIdentifier

	| randomId |
	[ randomId := self class identifierRange atRandom ] doWhileFalse:
		[ self isIdentifierAvailable: randomId ].
	
	^ randomId asString.! !

!S2JCometHandler methodsFor: 'request handling' stamp: 'HK 1/3/2011 14:04'!
handleGetRequest: aRequest

	| identifier |
	identifier := self extractIdentifierFrom: aRequest.
	identifier
		ifNil: [ ^ self registerNewClient ]
		ifNotNil: [ ^ self respondToClientWithId: identifier ].! !

!S2JCometHandler methodsFor: 'request handling' stamp: 'HK 1/3/2011 20:29'!
handlePostRequest: aRequest

	(self includesIdentifier: aRequest)
		ifTrue: [ ^ self updateContentFrom: aRequest ]
		ifFalse: [ ^ HTTPResponse forbidden ].! !

!S2JCometHandler methodsFor: 'convenience' stamp: 'HK 1/4/2011 14:12'!
hasNewDataFor: aClient

	S2JDispatcher content ifNil: [ ^ false ].
	^ (aClient isBehind).! !

!S2JCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 13:29'!
includesIdentifier: aRequest

	^ aRequest requestLine requestURI asString includesSubString: '?id='.! !

!S2JCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 14:11'!
isIdentifierAvailable: anIdentifier

	| allocatedIdentifiers |
	allocatedIdentifiers := S2JDispatcher clients
		select: [ :each | each isCometClient ]
		thenCollect: [ :each | each identifier ].
		
	 ^ (allocatedIdentifiers includes: anIdentifier) not.! !

!S2JCometHandler methodsFor: 'convenience' stamp: 'HK 12/17/2010 13:35'!
postDataOf: aRequest

	aRequest isPostDataEmpty ifTrue: [ ^ nil ].
	^ aRequest postData keys any.! !

!S2JCometHandler methodsFor: 'convenience' stamp: 'HK 1/3/2011 14:11'!
registerNewClient

	| identifier client |
	
	identifier := self generateIdentifier.
	client := (S2JCometClient new identifier: identifier).
	S2JDispatcher addClient: client.
	^ self answerNewIdentifier: identifier.! !

!S2JCometHandler methodsFor: 'responding' stamp: 'HK 1/10/2011 13:57'!
respondToClient: aClient

	[ self hasNewDataFor: aClient ] whileFalse:
		[ aClient decrementKeepAliveCount.
		aClient isAlive ifFalse: [
			S2JDispatcher removeClient: aClient.
			^ self answerNotModified ]. 
		self wait ].
	^ self answerNewContentTo: aClient ! !

!S2JCometHandler methodsFor: 'responding' stamp: 'HK 1/3/2011 14:23'!
respondToClientWithId: anIdentifier

	| client |
	client := self findClientById: anIdentifier.
	^ self respondToClient: client.! !

!S2JCometHandler methodsFor: 'suspending' stamp: 'HK 12/15/2010 20:15'!
suspendRequestAndExecute: aBlock
	
	self wait.	
	^ aBlock value.! !

!S2JCometHandler methodsFor: 'request handling' stamp: 'HK 1/3/2011 22:07'!
updateContentFrom: aRequest

	| client identifier |
	
	identifier := self extractIdentifierFrom: aRequest.
	client := self findClientById: identifier.
	client ifNotNil:
		[ client increaseRevision.
		S2JDispatcher updateContentWith: (self postDataOf: aRequest).
		S2JWebSocketHandler updateAllClients.
		^ self answerCreated ].! !

!S2JCometHandler methodsFor: 'suspending' stamp: 'HK 1/5/2011 16:43'!
wait

	self waitForMilliseconds: self class defaultMillisecondsToWait.! !

!S2JCometHandler methodsFor: 'suspending' stamp: 'HK 12/15/2010 20:15'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

S2JResource subclass: #S2JDispatcher
	instanceVariableNames: ''
	classVariableNames: 'Clients Content Resources Revision'
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JDispatcher class methodsFor: 'client handling' stamp: 'HK 1/3/2011 14:06'!
addClient: aClient

	self clients add: aClient.! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/3/2011 16:00'!
clients
	Clients ifNil: [ Clients := OrderedCollection new ].
	^ Clients! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/3/2011 11:15'!
clients: anObject
	Clients := anObject! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/3/2011 11:15'!
content
	^ Content! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/3/2011 11:15'!
content: anObject
	Content := anObject! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 1/3/2011 21:37'!
contentAtRevision: aNumber

	^ self content at: aNumber.! !

!S2JDispatcher class methodsFor: 'configuration' stamp: 'HK 12/17/2010 13:42'!
defaultRevision

	^ 0.! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 1/3/2011 13:23'!
increaseRevision

	self revision ifNil: [ self revision: 0 ].
	self revision: self revision + 1.! !

!S2JDispatcher class methodsFor: 'setup' stamp: 'HK 12/17/2010 13:52'!
install

	^ (SwazooSite
		newNamed: self siteName)
		host: '*'
		ip: '*'
		port: self defaultPort;
		addResource: (self uriPattern: '/');
		yourself.
	! !

!S2JDispatcher class methodsFor: 'setup' stamp: 'HK 1/4/2011 15:32'!
installOn: aPort

	^ (SwazooSite
		newNamed: self siteName)
		host: '*'
		ip: '*'
		port: aPort;
		addResource: (self uriPattern: '/');
		yourself.
	! !

!S2JDispatcher class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
isInstalled

	^ self site notNil.! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 1/3/2011 13:54'!
latestContent

	^ self content at: self revision.! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 1/4/2011 16:23'!
registerResource: aResource named: aName

	self resources
		at: aName
		put: aResource.! !

!S2JDispatcher class methodsFor: 'client handling' stamp: 'HK 1/3/2011 16:08'!
removeAllClients

	self clients
		select: [ :each | each isWebSocketClient ]
		thenDo: [ :each | each close ].
	self clients: nil.! !

!S2JDispatcher class methodsFor: 'client handling' stamp: 'HK 1/3/2011 22:23'!
removeClient: aClient

	self clients remove: aClient.! !

!S2JDispatcher class methodsFor: 'configuration' stamp: 'HK 12/8/2010 10:54'!
replacementDictionary

	^ Dictionary new
		at: '&' put: '%26';
		at: '<' put: '%3C';
		at: '>' put: '%3E';
		yourself.! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 12/17/2010 13:44'!
resetContent

	self
		revision: 0;
		content: nil.! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/4/2011 16:22'!
resources
	Resources ifNil: [ Resources := Dictionary new ].
	^ Resources! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/4/2011 16:21'!
resources: anObject
	Resources := anObject! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/3/2011 11:16'!
revision
	^ Revision! !

!S2JDispatcher class methodsFor: 'accessing' stamp: 'HK 1/3/2011 11:16'!
revision: anObject
	Revision := anObject! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'ag 1/4/2011 14:25'!
sendCode: aString
	
	^ self updateContentWithSqueakCode: aString! !

!S2JDispatcher class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
site

	^ SwazooServer singleton siteNamed: self siteName.! !

!S2JDispatcher class methodsFor: 'setup' stamp: 'HK 12/17/2010 13:55'!
start

	self isInstalled ifFalse: [ self install ].
	self site start.
! !

!S2JDispatcher class methodsFor: 'setup' stamp: 'HK 1/4/2011 14:33'!
uninstall

	self isInstalled ifTrue:
		[ self removeAllClients.
		self resetContent.
		SwazooServer singleton removeSite: self site ].! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 1/4/2011 11:21'!
updateContentWith: data

	self content ifNil: [ self content: Dictionary new ].
	self increaseRevision.
	self content
		at: self revision
		put: data.
	S2JWebSocketHandler updateAllClients.! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'ag 1/4/2011 14:30'!
updateContentWithSqueakCode: content

	| jsCode |
	[ jsCode := S2JPrinter convertDoIt: content ]
		on: Exception do: [ :err | jsCode := '"Could not parse squeak-code: ', Character cr asString, content, Character cr asString, 'Error was: ', err asString, '"' ].
	^ self updateContentWith: jsCode! !

!S2JDispatcher class methodsFor: 'convenience' stamp: 'HK 1/3/2011 18:04'!
webSocketClients

	^ self clients select: [ :each | each isWebSocketClient ].! !

!S2JDispatcher methodsFor: 'request handling' stamp: 'HK 1/10/2011 13:21'!
answerTo: aRequest 

	| resource response |
	
	resource := self pathOf: aRequest.
	response := self handle: aRequest for: resource.	
		
	^ response.! !

!S2JDispatcher methodsFor: 'dispatching' stamp: 'HK 12/17/2010 13:38'!
answerWebsiteTo: aRequest

	^ S2JApp new answerTo: aRequest.! !

!S2JDispatcher methodsFor: 'request handling' stamp: 'HK 1/4/2011 16:54'!
handle: aRequest

	| resource path |
	resource = self resourceIdentifierOf: aRequest.
	path = self pathOf: aRequest.

	(path = S2JResource applicationPath)
		ifTrue: [ ^ self answerWebsiteTo: aRequest ].
	(path = S2JResource webSocketPath) ifTrue:
		[ ^ self handleWebSocketRequest: aRequest ].
	(path = S2JResource cometPath) ifTrue:
		[ ^ self handleCometRequest: aRequest ].
	^ self redirectTo: self class applicationPath.! !

!S2JDispatcher methodsFor: 'request handling' stamp: 'HK 1/4/2011 16:57'!
handle: aRequest for: aResource

	Transcript show: aResource.

	(aResource = self class applicationPath)
		ifTrue: [ ^ self answerWebsiteTo: aRequest ].
	(aResource = self class webSocketPath) ifTrue:
		[ ^ self handleWebSocketRequest: aRequest ].
	(aResource = self class cometPath) ifTrue:
		[ ^ self handleCometRequest: aRequest ].
	^ self redirectTo: self class applicationPath.! !

!S2JDispatcher methodsFor: 'dispatching' stamp: 'HK 12/17/2010 13:37'!
handleCometRequest: aRequest

	^ S2JCometHandler new answerTo: aRequest.! !

!S2JDispatcher methodsFor: 'dispatching' stamp: 'HK 12/17/2010 13:36'!
handleWebSocketRequest: aRequest

	^ S2JWebSocketHandler new answerTo: aRequest.! !

!S2JDispatcher methodsFor: 'convenience' stamp: 'HK 1/5/2011 16:31'!
pathOf: aRequest

	"^ '/', ((aRequest requestLine requestURI identifier) findTokens: '/') second."
	^ aRequest requestLine requestURI identifier! !

!S2JDispatcher methodsFor: 'convenience' stamp: 'HK 1/4/2011 15:59'!
portOf: aRequest

	^ aRequest requestLine requestURI port.! !

!S2JDispatcher methodsFor: 'convenience' stamp: 'HK 1/4/2011 15:45'!
redirectTo: aPath

	^HTTPResponse new
		statusCode: 302;
		entity: '';
		location: aPath;
		yourself.! !

!S2JDispatcher methodsFor: 'convenience' stamp: 'HK 1/4/2011 16:33'!
resourceIdentifierOf: aRequest

	^ ((aRequest requestLine requestURI identifier) findTokens: '/') first.! !

!S2JResource class methodsFor: 'configuration' stamp: 'HK 12/15/2010 15:50'!
applicationPath

	^ '/app'.! !

!S2JResource class methodsFor: 'configuration' stamp: 'HK 12/15/2010 20:06'!
cometPath

	^ '/xhr'.! !

!S2JResource class methodsFor: 'configuration' stamp: 'HK 1/3/2011 11:13'!
defaultPort

	^ 8887.! !

!S2JResource class methodsFor: 'configuration' stamp: 'HK 12/17/2010 13:43'!
siteName

	^ 'S2JWebApp'.! !

!S2JResource class methodsFor: 'configuration' stamp: 'HK 12/15/2010 15:49'!
webSocketPath

	^ '/ws'.! !

!S2JResource methodsFor: 'responding' stamp: 'HK 12/17/2010 13:57'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!S2JResource methodsFor: 'responding' stamp: 'HK 12/15/2010 17:15'!
answerCreated

	^ self answerWithStatusCode: 201.! !

!S2JResource methodsFor: 'responding' stamp: 'HK 1/10/2011 13:53'!
answerNotModified

	^ self answerWithStatusCode: 304.! !

!S2JResource methodsFor: 'responding' stamp: 'HK 12/15/2010 17:16'!
answerWithStatusCode: aNumber

	^ self answerWithStatusCode: aNumber andContent: ''.! !

!S2JResource methodsFor: 'responding' stamp: 'HK 12/15/2010 15:47'!
answerWithStatusCode: aNumber andContent: content

	^ HTTPResponse ok
		statusCode: aNumber;
		entity: content.! !

S2JResource subclass: #S2JWebSocketHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebSocketHandler class methodsFor: 'configuration' stamp: 'HK 1/4/2011 12:17'!
millisecondsToWaitForHandshake

	^ 200.! !

!S2JWebSocketHandler class methodsFor: 'client handling' stamp: 'HK 1/4/2011 11:19'!
updateAllClients

	S2JDispatcher webSocketClients do: [ :each |
		each update ].! !

!S2JWebSocketHandler class methodsFor: 'client handling' stamp: 'HK 1/3/2011 22:33'!
updateAllClientsExcept: aClient
	
	aClient increaseRevision.
	S2JDispatcher webSocketClients
		reject: [ :uniqueClient | uniqueClient = aClient ]
		thenDo: [ :each | each update ].! !

!S2JWebSocketHandler methodsFor: 'request handling' stamp: 'ag 1/4/2011 14:56'!
answerTo: aRequest

	| webSocket |
	webSocket := aRequest webSocket.
	(self isNew: webSocket ) ifTrue: 
		[ self setupClientWith: webSocket ].
	^ webSocket answerTo: aRequest.! !

!S2JWebSocketHandler methodsFor: 'convenience' stamp: 'HK 1/3/2011 21:56'!
isNew: aWebSocket

	| registeredSockets |
	registeredSockets := S2JDispatcher webSocketClients collect:
		[ :each | each socket ].
	
	^ (registeredSockets includes: aWebSocket) not.! !

!S2JWebSocketHandler methodsFor: 'convenience' stamp: 'ag 1/4/2011 14:56'!
setupClientWith: aWebSocket

	| client |
	client := (S2JWebSocketClient newWithSocket: aWebSocket).
	S2JDispatcher addClient: client.
	self updateDelayed: client.! !

!S2JWebSocketHandler methodsFor: 'convenience' stamp: 'HK 1/4/2011 12:12'!
updateDelayed: aClient

	[ (Delay forMilliseconds: self class millisecondsToWaitForHandshake) wait. 
	aClient update ] fork.! !

!Number methodsFor: '*SwazooSpike' stamp: 'HK 12/13/2010 12:46'!
asByteArray

	| targetByteArray |
	targetByteArray := ByteArray new: 4.
	Bitmap new encodeBytesOf: self in: targetByteArray at: 1.
	^ targetByteArray.! !

TestCase subclass: #S2JSwazooTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

S2JSwazooTests subclass: #S2JCometHandlerTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/10/2011 13:26'!
basicGetFor: aPath

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		crlf.
	^ HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).! !

!S2JCometHandlerTests methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client
	^ client! !

!S2JCometHandlerTests methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client: anObject
	client := anObject! !

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/5/2011 16:58'!
setUp

	self client: S2JCometClient new.! !

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/10/2011 13:26'!
testCreateNewId

	| oldCount newCount response |
	oldCount := S2JDispatcher clients size.
	response := S2JDispatcher new answerTo: (self basicGetFor: S2JDispatcher cometPath).
	self assert: response notNil.
	newCount := S2JDispatcher clients size.
	self assert: newCount = (oldCount + 1).! !

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/5/2011 17:08'!
testDecrementUntilDeath

	S2JCometClient defaultKeepAliveCount timesRepeat:
		[ self assert: self client isAlive.
		self client decrementKeepAliveCount ].
	self deny: self client isAlive.! !

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/5/2011 16:58'!
testIsInitiallyAlive

	| cometClient |
	cometClient := S2JCometClient new.
	self assert: cometClient isAlive.! !

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/10/2011 14:01'!
testRemoveDeadClient

	| clientId response |
	response := S2JDispatcher new answerTo:
		(self basicGetFor: S2JDispatcher cometPath).
	clientId := response body asString.
	self client: (S2JCometHandler new findClientById: clientId).
	self assert: (self client notNil).
	self assert: (self client isAlive).
	self client keepAliveCount: 1.
	response := S2JDispatcher new answerTo:
		(self basicGetFor: S2JDispatcher cometPath, '?id=', clientId).
	self assert: (response statusCode = 304).
	self assert: ((S2JCometHandler new findClientById: clientId) isNil).! !

!S2JCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'HK 1/5/2011 17:14'!
testUpdatesKeepAlive

	(S2JCometClient defaultKeepAliveCount - 1) timesRepeat:
		[ self assert: self client isAlive.
		self client decrementKeepAliveCount ].
	self client increaseRevision.
	self client decrementKeepAliveCount.
	self assert: self client isAlive.! !

S2JSwazooTests subclass: #S2JDispatcherTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!
